#############################################################################
##
#W    subgroupcomplexes.gd    share package 'homology'                 Welker
##
## Partially ordered sets and simplicial complexes arising in the study    
## of the structure of the subgroup-lattice and parts of it of a finite group.

#==================================================
# Posets from groups 
#==================================================

#############################################################################
##
#F  PosetOfConjugacyClasses ( <g> )
##
##  constructs the poset of conjugacy classes of subgroups of the group `<g>'
##
DeclareGlobalFunction("PosetOfConjugacyClasses");

#############################################################################
##
#F  LatticeOfSubgroups( <g> )
##
##  constructs the lattice of subgroups of the group `<g>'
##
DeclareGlobalFunction("LatticeOfSubgroups");


#############################################################################
##
#F  IsElementaryAbelianPGroup ( <g> , <p> )
##
##  returns true if `<g>' is an elementary Abelian `<p>'-group and false
##  otherwise.
##
DeclareGlobalFunction("IsElementaryAbelianPGroup");

#############################################################################
##
#F  QuillenPoset ( <g> , <p> )
##
##  constructs the poset of elementary abelian `<p>'-subgroups of the 
##  group `<g>' for a prime number `<p>'.
##
DeclareGlobalFunction("QuillenPoset");

#############################################################################
##
#F  PosetOfCosets ( <g> )
##
##  constructs the partially ordered set of all cosets of the subgroups
##  of the group `<g>' ordered by inclusion.
##
DeclareGlobalFunction("PosetOfCosets");
