{
  Copyright 1997-99 by Frank Heckenbach, heckenb@mi.uni-erlangen.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, version 2.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit Tools;

interface

uses Commentator_Pas;

const
  haInteger      = 1;
  haGMP          = 2;
  haValenceElim  = 3;
  haValenceBB    = 4;

  hmGroup        = 0;
  hmBetti        = 1;
  hmNTorsionRank = 2;
  hmMatrix       = 3;
  hmMatrixFile   = 4;

  {Maximal erlaubte Homologie-Dimension}
  MaximumDim=256;

  {Anzahl der Schritte, nach denen jeweils Fortschrittsmeldungen
   beim Berechnen der Homologiegruppen ausgegeben werden.
   Der Wert 0 bewirkt, dass keine Meldungen gegeben werden.}
  MsgStep=1000;

  {Anzahl der Schritte, nach denen jeweils Fortschrittsmeldungen
   beim Berechnen der Torsionen ausgegeben werden.
   Der Wert 0 bewirkt, dass keine Meldungen gegeben werden.}
  MsgStep2=10;

  {Maximale Dimension von Arrays}
  MaxArray=$10000000;

  {Groesse der Hash-Tabelle fuer die Punkt-Strings}
  Hash_Size=$4000;

type
  Dim0=0..MaximumDim;
  Dim1=1..MaximumDim;

  {Typ fuer die Nummern der Punkte in Seiten und Facetten}
  TElementCount=Cardinal;

  {Allgemeiner Zaehltyp}
  TCount=Integer;

  {Sparse Vector aus Integers}
  TIntVectorElement=record
    Index:TCount;
    Val:Integer
  end;

  PSparseIntVector=^TSparseIntVector;
  TSparseIntVector(Size:TCount)=record
    Count:0..Size;
    Elements:array[0..Size-1] of TIntVectorElement
  end;

var
  Commentator : TCommentator;

procedure Abort (const Message : String);

implementation

{$B-}

procedure Abort (const Message : String);
begin
  ActivityReport (Commentator, Message, LvlNormal, InternalError);
  Halt (5)
end;

end.
