// ==========================================================================
// $Source: /users/huron/gautier/projets/CVS/Givaro/src/kernel/system/givinit.C,v $
// Copyright(c)'94-97 by Givaro Team
// see the copyright file.
// Authors: T. Gautier
// $Id: givinit.C,v 1.0.0.1 1999/04/15 10:13:54 gautier Exp $
// ==========================================================================
// Description:
//  - Initialisation method

#include <iostream.h>
#include "givinit.h"
#include "givmodule.h"
#include "givaromm.h"
#include "giverror.h"

#if (GIVAROSYS == MacOS)
#  if (__profile__ == 1)
#    pragma only_std_keywords off
#    include <profiler.h>
#    pragma only_std_keywords reset
#  endif
#endif


void Givaro::DisplayVersion()
{
  Givaro::DisplayVersion( cout ) ;
}

void Givaro::DisplayVersion(ostream& o)
{
static const char* Givaro_version ="$Revision: 1.0.0.1 $ for ""GIVAROSYS"; 
o<<'\n' ;
o<<"      /\\ \n" ;
o<<"     /  \\    /\\      GIVARO : Parallel Algebraic Computing\n" ;
o<<"    /\\__/\\  /  \\     by the Givaro Team\n" ;
o<<"   /      \\/\\__/\\    All rights reserved, see copyright file.\n" ;
o<<"  /              \\ " ;
o<<" /     Givaro-1.0 \\  Authors:\n" ;
o<<"/   (c) 1987-1998  \\    Th. Gautier, J.L. Roch, M.Samama, G.Villard\n" ;
o<<"--   -   -  -  -  --\n" ;
o<< "version: " << Givaro::Version() << endl;
} 

const char* Givaro::Version()
{
  static const char* Givaro_version ="$Revision: 1.0.0.1 $ for ""GIVAROSYS"; 
  return Givaro_version;
}

void Givaro::Init(int* argc, char***argv) 
{
  GivModule::InitApp(argc, argv) ;
}

void Givaro::Init() 
{
  Givaro::Init(0,0) ;
}

  // End of Givaro kernel :
void Givaro::End()
{
  GivModule::EndApp() ;
}

// -- run: must be call by the user on its application object
int GivaroAppli::run( int argc, char** argv)
{
  int res = 0;
#if (GIVAROSYS == MacOS)
#if ( __profile__ == 1)
  OSErr err = ProfilerInit(collectDetailed, bestTimeBase, 100,10);
  if (err != noErr) {
    cout << GivError("[Givaro::Init]: cannot initiliaze profile.");  
    return 0;
  }  
  ProfilerSetStatus(true);
#endif
#endif
  // -- call main function
  try {
    Givaro::Init(&argc, &argv);
    res = main(argc,argv);
    Givaro::End();
  }
  catch (GivError E) { cout << E << endl; }
  catch (...) { cout << "[GivaroAppli::run]: an error has occurred." << endl; }

#if (GIVAROSYS == MacOS)
#if (__profile__ == 1)
  ProfilerSetStatus(false);
  err = ProfilerDump("\pprofile.log");
  ProfilerTerm( );
  if (err != noErr) throw GivError("[Givaro::End]: cannot dump profile results.");
#endif
#endif

  return res;
}
